//+------------------------------------------------------------------+
//|                                       ArtificialIntelligence.mq5 |
//|                                          Copyright 2012, Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link "https://login.mql5.com/ru/users/Integer"
#property description ""
#property version   "1.00"
#property description "   MQ4,  Reshetov (http://www.mql4.com/ru/users/Reshetov),    - http://codebase.mql4.com/ru/756"

#include <Trade/Trade.mqh>
#include <Trade/SymbolInfo.mqh>
#include <Trade/DealInfo.mqh>
#include <Trade/PositionInfo.mqh>

CTrade Trade;
CDealInfo Deal;
CSymbolInfo Sym;
CPositionInfo Pos;

/*

   : Reshetov, http://www.mql4.com/ru/users/Reshetov
   
   : http://codebase.mql4.com/ru/756

    :    AC   .

    :
   
     AC,    4-   : Shift, Shift+7, Shift+14, Shift+21.           (100-x(n)),  x(n) -   x1, x2, x2, x3.          .       0  ,     - . 
   
       ( )   .          ,      ,    ,     .    ,  ,    ,        (       ). 
   
   , ,     -   ,    ,           .

      ,            ,       .   


*/
   
//--- input parameters
input double   Lots              =  0.1;     /*Lots*/             // 
input int      StopLoss          =  850;     /*StopLoss*/         //   .
input int      Shift             =  1;       /*Shift*/            //     : 0 -  , 1 -   
input int      x1                =  135;     /*x1*/               //    0  200
input int      x2                =  127;
input int      x3                =  16;
input int      x4                =  93;

int Handle=INVALID_HANDLE;
double a1[1],a2[1],a3[1],a4[1];

datetime ctm[1];
datetime LastTime;
double lot,slv,msl,mtp;
double perc;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){

   //  ...
   
   Handle=iAC(_Symbol,PERIOD_CURRENT);

   if(Handle==INVALID_HANDLE){
      Alert("  ,  ");
      return(-1);
   }   
   
   if(!Sym.Name(_Symbol)){
      Alert("  CSymbolInfo,  ");    
      return(-1);
   }

   Print("  ");
   
   return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   if(Handle!=INVALID_HANDLE)IndicatorRelease(Handle);
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){

   if(CopyTime(_Symbol,PERIOD_CURRENT,0,1,ctm)==-1){
      return;
   }
   
   if(Shift==0 || ctm[0]!=LastTime){
      
         // 
         if(!Indicators()){
            return;
         }   
      
      // 
      bool OpenBuy=SignalOpenBuy();
      bool OpenSell=SignalOpenSell();
      
         if(OpenBuy || OpenSell){
            if(!Sym.RefreshRates())return;              
         
         
            if(Pos.Select(_Symbol)){
               switch(Pos.PositionType()){
                  case POSITION_TYPE_BUY:
                     if(Sym.Bid()>(Pos.StopLoss()+(StopLoss*2+Sym.Spread())*Sym.Point())){
                        
                           if(OpenSell){
                              slv=SolveSellSL(StopLoss);
                                 if(CheckSellSL(slv)){                           
                                    lot=NormalizeDouble(Pos.Volume()+Lots,2);
                                    Trade.SetDeviationInPoints(Sym.Spread()*3);
                                       if(!Trade.Sell(lot,_Symbol,0,slv,0,"")){
                                          return;
                                       }
                                 }
                                 else{
                                    Print(" buy-sell  ,  ");
                                    Trade.PositionClose(_Symbol,Sym.Spread()*3);
                                    return;
                                 }
              
                           }
                           else{
                              slv=SolveBuySL(StopLoss);
                                 if(CheckBuySL(slv)){  
                                    Trade.PositionModify(_Symbol,slv,0);
                                 }
                           }
                     }
                  break;
                  case POSITION_TYPE_SELL:
                     if(Sym.Ask()<(Pos.StopLoss()-(StopLoss*2+Sym.Spread())*Sym.Point())){
                           if(OpenBuy){
                              slv=SolveBuySL(StopLoss);
                                 if(CheckBuySL(slv)){
                                    lot=NormalizeDouble(Pos.Volume()+Lots,2);
                                    Trade.SetDeviationInPoints(Sym.Spread()*3);
                                       if(!Trade.Buy(Lots,_Symbol,0,slv,0,"")){
                                          return;
                                       }
                                 }
                                 else{
                                    Print(" buy-sell  ,  ");
                                    Trade.PositionClose(_Symbol,Sym.Spread()*3);
                                    return;
                                 }                                    
                           }
                           else{
                              slv=SolveSellSL(StopLoss);
                                 if(CheckSellSL(slv)){  
                                    Trade.PositionModify(_Symbol,slv,0);
                                 }
                           }                 
                     }
                  break;
               }
            }
            else{
               if(OpenBuy && !OpenSell){ 
                  slv=SolveBuySL(StopLoss);
                     if(CheckBuySL(slv)){
                        Trade.SetDeviationInPoints(Sym.Spread()*3);
                        
                        if(!Trade.Buy(Lots,_Symbol,0,slv,0,"")){
                           return;
                        }
                     }
                     else{
                        Print(" Buy  ,    ");
                     }         
               }
               // 
               if(OpenSell && !OpenBuy){
                  slv=SolveSellSL(StopLoss);
                     if(CheckSellSL(slv)){
                        Trade.SetDeviationInPoints(Sym.Spread()*3);
                        if(!Trade.Sell(Lots,_Symbol,0,slv,0,"")){
                           return;
                        }
                     }
                     else{
                        Print(" Sell  ,    ");
                     }          
               }
            }
         }
      LastTime=ctm[0];
   }
}

//+------------------------------------------------------------------+
//| The PERCEPTRON - a perceiving and recognizing function           |
//+------------------------------------------------------------------+
double perceptron(){
   double w1 = x1 - 100;
   double w2 = x2 - 100;
   double w3 = x3 - 100;
   double w4 = x4 - 100;
   return(w1*a1[0]+w2*a2[0]+w3*a3[0]+w4*a4[0]);
}

//+------------------------------------------------------------------+
//|      ,                    |
//+------------------------------------------------------------------+
bool Indicators(){
   if(
      CopyBuffer(Handle,0,Shift,1,a1)==-1 ||
      CopyBuffer(Handle,0,Shift+7,1,a2)==-1 ||
      CopyBuffer(Handle,0,Shift+14,1,a3)==-1 ||
      CopyBuffer(Handle,0,Shift+21,1,a4)==-1
   ){
      return(false);
   }      
   perc=perceptron();
   return(true);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenBuy(){
   return(perc>0);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenSell(){
   return(perc<0);
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
double SolveBuySL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()-Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      sell                               |
//+------------------------------------------------------------------+
double SolveSellSL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()+Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|       buy                  |
//+------------------------------------------------------------------+
double BuyMSL(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell                 |
//+------------------------------------------------------------------+
double SellMSL(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|      buy                                 |
//+------------------------------------------------------------------+
bool CheckBuySL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice<BuyMSL());
}

//+------------------------------------------------------------------+
//|      sell                                 |
//+------------------------------------------------------------------+
bool CheckSellSL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice>SellMSL());
}
